//AD-routines
#include <avr/interrupt.h>
#include <avr/io.h>
#include "io.h"

#define BMAX 700
volatile unsigned char rcvd;
volatile unsigned char sending=0;
volatile unsigned short wpos=0;
volatile unsigned short rpos=0;
volatile unsigned char buff[BMAX];
volatile unsigned char sentdash;
volatile unsigned char mode;


void send(unsigned char c) {
    PORTC|=2;
    UCSR0B|=(1<<5);
    UDR0=c;
    sending=1;
}

char nib2h(unsigned char n) {
    if (n<10) return n+'0';
    if (n<16) return (n-10)+'A';
    return 'X';
}

void wptr(char v) {
    sentdash=0;
    if (wpos==(rpos-1)) {
	buff[wpos-1]='*';
    } else {
	buff[wpos++]=v;
	if (wpos>=BMAX) wpos=0;
	if (!sending) send(buff[rpos++]);
    }
}


ISR(USART_RX_vect) {
    char *h="0123456789ABCDEF-x";
    char t;
    char s;
    t=UDR0;
    if (t=='R') {
	wptr('K');
	mode=0;
	setmode(mode);
    } else if (t=='S') {
	wptr('K');
	mode=1;
	setmode(mode);
    } else {
	if (mode) {
	    s=0;
	    while (h[s]!=t && h[s]!='x') s++;
	    if (h[s]=='x') {
		wptr('?');
	    } else {
		wptr(t);
		if (t=='-') {
		    raisecs();
		} else {
		    bangnibble(s);
		}
	    }
	} else {
	    wptr('?');
	}
    }
}


ISR(USART_UDRE_vect) {
    if (wpos!=rpos) {
	send(buff[rpos++]);
	if (rpos>=BMAX) rpos=0;
    } else {
	if (!sentdash) {
//	    wptr('-');
	    sentdash=1;
	} else {
	    sending=0;    
	    UCSR0B&=~(1<<5);
	    PORTC&=~2;
	}
    }
}


ISR(SPI_STC_vect) {
    unsigned char d;
    if (PINB&(1<<2)) return;
    d=SPDR;
    wptr(nib2h(d>>4));
    wptr(nib2h(d&15));
    rcvd=1;
//    wptr(' ');
}
